﻿Import "-stdlib=libc++ -mmacosx-version-min=10.7" : EndImport

Procedure SizeWindowHandler()
  ResizeGadget(0, #PB_Ignore, #PB_Ignore, WindowWidth(0), WindowHeight(0))
EndProcedure

Procedure BuildPDF(PDFFolder.s)
  If OpenWindow(0, 0, 0, 800, 700, "HTML5 PDFJS: PDF Viewer", #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_SizeGadget | #PB_Window_ScreenCentered | #PB_Window_Invisible)
    WebGadget(0, 0, 0, 800, 700, #Null$)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setJavaScriptEnabled:", #YES)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setWebSecurityEnabled:", #NO)
    SetGadgetAttribute(0, #PB_Web_BlockPopupMenu, #True)
    SetGadgetAttribute(0, #PB_Web_BlockPopups, #True)
    PDFJS.s = PeekS(?pdfFile_Start, ?pdfFile_End - ?pdfFile_Start, #PB_UTF8)
    PDFJS = ReplaceString(PDFJS, "viewer.css", "file:///" + PDFFolder + "Includes/PDFJS/viewer.css")
    PDFJS = ReplaceString(PDFJS, "l10n.js", "file:///" + PDFFolder + "Includes/PDFJS/l10n.js")
    PDFJS = ReplaceString(PDFJS, "pdf.js", "file:///" + PDFFolder + "Includes/PDFJS/pdf.js")
    PDFJS = ReplaceString(PDFJS, "pdf.worker.js", "file:///" + PDFFolder + "Includes/PDFJS/pdf.worker.js")
    PDFJS = ReplaceString(PDFJS, "viewer.js", "file:///" + PDFFolder + "Includes/PDFJS/viewer.js")
    SetGadgetItemText(0, #PB_Web_HtmlCode, PDFJS)
    BindEvent(#PB_Event_SizeWindow, @SizeWindowHandler())
    Repeat : nWait + 1 : WindowEvent() : Delay(1) : Until nWait = 300
    SmartWindowRefresh(0, #True) : StickyWindow(0, 1) : HideWindow(0, 0)
    Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
  EndIf
EndProcedure

PDFFolder.s = GetCurrentDirectory()
BuildPDF(PDFFolder)

DataSection
  pdfFile_Start:
    IncludeBinary "Includes/PDFJS/viewer.html"
  pdfFile_End:
EndDataSection
; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 1
; Folding = -
; UseIcon = Binaries/pdf.icns
; DisableDebugger
; EnableUnicode