﻿CompilerIf #PB_Compiler_Version < 550
  #MR_ICONINFORMATION = #Null
  #MR_ICONERROR = #Null
CompilerElse
  #MR_ICONINFORMATION = #PB_MessageRequester_Info
  #MR_ICONERROR = #PB_MessageRequester_Error
CompilerEndIf

Import "-stdlib=libc++ -mmacosx-version-min=10.7" : EndImport

Procedure.s CreateBook(ImageLocation.s, CurrentLocation.s)
  If OpenWindow(0, 0, 0, 300, 100, "HTML5 TurnJS: Create Double Page", #PB_Window_ScreenCentered | #PB_Window_Invisible)
    WebGadget(0, 0, 0, 300, 100, #Null$) : HideGadget(0, #True)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setJavaScriptEnabled:", #YES)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setWebSecurityEnabled:", #NO)
    TextGadget(1, 0, 40, 300, 20, "Building Book...", #PB_Text_Center)
    SetGadgetAttribute(0, #PB_Web_BlockPopups, #True)

    If ExamineDirectory(0, ImageLocation, "*.jpg")
      HideWindow(0, #False) : StickyWindow(0, #True)

      While FileSize(CurrentLocation + "TestFiles/Book" + Str(FolderNumber + 1)) <> -1
        FolderNumber + 1
      Wend
      CreateDirectory(CurrentLocation + "TestFiles/Book" + Str(FolderNumber + 1) + "/")
      CreateDirectory(CurrentLocation + "TestFiles/Book" + Str(FolderNumber + 1) + "/pages/")
      PageLocation.s = CurrentLocation + "TestFiles/Book" + Str(FolderNumber + 1) + "/pages/"

      If FileSize(PageLocation)
        ADS.s = "[ZoneTransfer]" + #CRLF$ + "ZoneId=3"
        nLength = StringByteLength(ADS, #PB_Unicode)

        While NextDirectoryEntry(0)
          If DirectoryEntryType(0) = #PB_DirectoryEntry_File
            FileName.s = DirectoryEntryName(0) : nCount + 1
            SetGadgetText(1, "Building Book... Page: " + Str(nCount))
            CopyFile(ImageLocation + FileName, PageLocation + Str(nCount) + ".jpg")

            If CreateFile(0, PageLocation + Str(nCount) + ".jpg:Zone.Identifier")
              WriteData(0, @ADS, nLength) : CloseFile(0)
              HTML.s = "<html>" + #LF$ +
                       #TAB$ + "<head><script>" + #LF$ +
                       #TAB$ + #TAB$ + "function getImageSize(){" + #LF$ +
                       #TAB$ + #TAB$ + #TAB$ + "var image=document.getElementById('image');" + #LF$ +
                       #TAB$ + #TAB$ + #TAB$ + "var width=image.clientWidth;" + #LF$ +
                       #TAB$ + #TAB$ + #TAB$ + "var height=image.clientHeight;" + #LF$ +
                       #TAB$ + #TAB$ + #TAB$ + "var complete=image.complete;" + #LF$ +
                       #TAB$ + #TAB$ + #TAB$ + "if(complete==true){document.title=width+'x'+height;}else{document.title='JHPJHP'}" + #LF$ +
                       #TAB$ + #TAB$ + "}" + #LF$ +
                       #TAB$ + "</script></head>" + #LF$ +
                       #TAB$ + "<body onload='getImageSize()'>" + #LF$ +
                       #TAB$ + #TAB$ + "<img id='image' src='" + PageLocation + Str(nCount) + ".jpg" + "'>" + #LF$ +
                       #TAB$ + "</body>" + #LF$ +
                       "</html>"
              SetGadgetItemText(0, #PB_Web_HtmlCode, HTML)

              Repeat
                If FindString(GetGadgetItemText(0, #PB_Web_HtmlCode), PageLocation + Str(nCount) + ".jpg") And GetGadgetItemText(0, #PB_Web_PageTitle) <> "" : Break : EndIf : WindowEvent() : Delay(1)
              ForEver
              PageTitle.s = GetGadgetItemText(0, #PB_Web_PageTitle)
              nPosition = FindString(PageTitle, "x")
              iWidth = Val(Left(PageTitle, nPosition))
              iHeight = Val(Mid(PageTitle, nPosition + 1))

              If iHeight > nHeight : nHeight = iHeight : EndIf

              If iWidth > iHeight
                If iWidth > nWidth1 : nWidth1 = iWidth : EndIf

                FlipBook.s + #TAB$ + #TAB$ + #TAB$ + #TAB$ + #TAB$ +
                             "<div class='double' style='background-image:url(" + #DQUOTE$ + PageLocation + Str(nCount) + ".jpg" + #DQUOTE$ + ")'></div>" + #LF$
              Else
                If iWidth > nWidth2 : nWidth2 = iWidth : EndIf

                FlipBook + #TAB$ + #TAB$ + #TAB$ + #TAB$ + #TAB$ +
                           "<div class='page' style='background-image:url(" + #DQUOTE$ + PageLocation + Str(nCount) + ".jpg" + #DQUOTE$ + ")'></div>" + #LF$
              EndIf
            EndIf
          EndIf
        Wend
        PageLocation = ReverseString(PageLocation)
        PageLocation = Mid(PageLocation, FindString(PageLocation, "/", 2))
        PageLocation = ReverseString(PageLocation)

        If CreateFile(0, PageLocation + "FlipBook.div")
          WriteString(0, FlipBook)
          CloseFile(0)
        EndIf

        If CreateFile(0, PageLocation + "FlipBook.div:SizeFB")
          WriteString(0, Str(nWidth1) + ":" + Str(nWidth2) + "x" + Str(nHeight))
          CloseFile(0)
        EndIf
      EndIf
      FinishDirectory(0)
      HideWindow(0, #True)
    EndIf
  EndIf
  ProcedureReturn PageLocation
EndProcedure

CurrentLocation.s = GetCurrentDirectory()
ImageLocation.s = PathRequester("Select a folder containing JPEG image files:", CurrentLocation + "TestFiles/")

If FileSize(ImageLocation) = -2
  PageLocation.s = CreateBook(ImageLocation, CurrentLocation)

  If PageLocation
    MessageRequester("HTML5 TurnJS: Create Double Page", "Your book has been created successfully." + #CRLF$ + #CRLF$ + PageLocation, #MR_ICONINFORMATION)
  Else
    MessageRequester("HTML5 TurnJS: Create Double Page", "There was an error creating your book." + #CRLF$ + #CRLF$ + PageLocation, #MR_ICONERROR)
  EndIf
EndIf
; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 7
; Folding = -
; UseIcon = Binaries/book.icns
; DisableDebugger
; EnableUnicode