﻿Import "-stdlib=libc++ -mmacosx-version-min=10.7" : EndImport

Procedure BuildBook(FlipBook.s, BookFolder.s, BookFile.s)
  If OpenWindow(0, 0, 0, 500, 500, "HTML5 TurnJS: Double Page", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
    WebGadget(0, 0, 0, 500, 500, #Null$)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setJavaScriptEnabled:", #YES)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setWebSecurityEnabled:", #NO)
    SetGadgetAttribute(0, #PB_Web_BlockPopupMenu, #True)
    SetGadgetAttribute(0, #PB_Web_BlockPopups, #True)

    If ReadFile(0, BookFile + ":SizeFB")
      SizeFB.s = ReadString(0, #PB_Ascii, 20)
      CloseFile(0)
    EndIf
    nPosition1 = FindString(SizeFB, ":")
    nPosition2 = FindString(SizeFB, "x")
    iWidth1 = Val(Left(SizeFB, nPosition1))
    iWidth2 = Val(Mid(SizeFB, nPosition1 + 1, nPosition2 - nPosition1))
    iHeight = Val(Mid(SizeFB, nPosition2 + 1))

    If iWidth2 * 2 > iWidth1 : iWidth = iWidth2 * 2 : Else : iWidth = iWidth1 : EndIf

    ExamineDesktops()
    DesktopWidth = DesktopWidth(0)
    DesktopHeight = DesktopHeight(0)

    If iWidth > DesktopWidth Or iHeight > DesktopHeight
      nRatio1 = DesktopWidth / iWidth
      nRatio2 = DesktopHeight / iHeight

      If nRatio1 < nRatio2
        BookWidth = DesktopWidth - 40
        nRatio.d = BookWidth / iWidth
        BookHeight = iHeight * nRatio
      Else
        BookHeight = DesktopHeight - 40
        nRatio.d = BookHeight / iHeight
        BookWidth = iWidth * nRatio
      EndIf
    Else
      BookWidth = iWidth : BookHeight = iHeight
    EndIf
    StyleCSS.s = #TAB$ + #TAB$ + "<style>" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + "body{" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + #TAB$ + "background-color:#006600;" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + "}" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + ".flipbook-viewport .flipbook{" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + #TAB$ + "width:" + Str(BookWidth) + "px;" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + #TAB$ + "height:" + Str(BookHeight) + "px;" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + #TAB$ + "left:" + Str((BookWidth) / 2 * -1) + "px;" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + #TAB$ + "top:" + Str((BookHeight) / 2 * -1) + "px;" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + "}" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + ".flipbook-viewport .page{" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + #TAB$ + "width:" + Str((BookWidth) / 2) + "px;" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + #TAB$ + "height:" + Str(BookHeight) + "px;" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + #TAB$ + "cursor:pointer;" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + "}" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + ".flipbook-viewport .double{" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + #TAB$ + "width:" + Str(BookWidth) + "px;" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + #TAB$ + "height:" + Str(BookHeight) + "px;" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + #TAB$ + "cursor:pointer;" + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + "}" + #LF$ +
                 #TAB$ + #TAB$ + "</style>" +  #LF$
    ScriptJS.s = #TAB$ + #TAB$ + #TAB$ + #TAB$ + #TAB$ + "width:" + Str(BookWidth) + "," + #LF$ +
                 #TAB$ + #TAB$ + #TAB$ + #TAB$ + #TAB$ + "height:" + Str(BookHeight) + "," + #LF$
    IncludeFile "Includes/turnjs_double.pbi"
    SetGadgetItemText(0, #PB_Web_HtmlCode, DoublePage)
    Repeat : nWait + 1 : WindowEvent() : Delay(1) : Until nWait = 200
    ResizeWindow(0, DesktopWidth / 2 - BookWidth / 2 - 10, DesktopHeight / 2 - BookHeight / 2 - 15, BookWidth, BookHeight)
    ResizeGadget(0, 0, 0, BookWidth, BookHeight)
    StickyWindow(0, 1) : HideWindow(0, 0)
    Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
  EndIf
EndProcedure

Pattern.s = "DIV Files (*.div)|*.div"
BookFile.s = OpenFileRequester("Choose the DIV file associated with the book you want opened.", GetCurrentDirectory() + "TestFiles/", Pattern, 0)

If FileSize(BookFile) > 0
  If ReadFile(0, BookFile)
    While Not Eof(0)
      FlipBook.s + ReadString(0) + #LF$
    Wend
    CloseFile(0)

    If FlipBook
      BookFolder.s = GetCurrentDirectory()
      BuildBook(FlipBook, BookFolder, BookFile)
    EndIf
  EndIf
EndIf
; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 1
; Folding = -
; UseIcon = Binaries/book.icns
; DisableDebugger
; EnableUnicode