﻿CompilerIf #PB_Compiler_Version < 550
  #MR_ICONSTOP = #Null
CompilerElse
  #MR_ICONSTOP = #PB_MessageRequester_Error
CompilerEndIf

Import "-stdlib=libc++ -mmacosx-version-min=10.7" : EndImport

Procedure BuildPlayer(VideoFile.s, VideoFolder.s, VideoZoom.d = 1)
  If OpenWindow(0, 0, 0, 500, 500, "HTML5 VideoJS: Player", #PB_Window_SystemMenu | #PB_Window_ScreenCentered | #PB_Window_Invisible)
    WebGadget(0, 0, 0, 500, 500, #Null$) : WebGadget(1, 0, 0, 0, 0, #Null$) : HideGadget(1, 1)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setJavaScriptEnabled:", #YES)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setWebSecurityEnabled:", #NO)
    CocoaMessage(0, CocoaMessage(0, GadgetID(1), "preferences"), "setJavaScriptEnabled:", #YES)
    CocoaMessage(0, CocoaMessage(0, GadgetID(1), "preferences"), "setWebSecurityEnabled:", #NO)
    SetGadgetAttribute(0, #PB_Web_BlockPopupMenu, #True)
    SetGadgetAttribute(0, #PB_Web_BlockPopups, #True)
    SetGadgetAttribute(1, #PB_Web_BlockPopups, #True)
    IncludeFile "Includes/videojs_player.pbi"
    SetGadgetItemText(1, #PB_Web_HtmlCode, VideoPlayer)

    Repeat
      PageTitle.s = GetGadgetItemText(1, #PB_Web_PageTitle)

      If FindString(GetGadgetItemText(1, #PB_Web_HtmlCode), VideoFile) And PageTitle <> "" : Break : EndIf : WindowEvent() : Delay(1)

    ForEver

    If PageTitle = "error"
      If FileSize(VideoFolder + "TestFiles/moon.mp4") > 0
        BuildPlayer(VideoFolder + "TestFiles/moon.mp4", VideoFolder, 0.7)
      Else
        MessageRequester("HTML5 Video Player with jQuery", "It seems that this video file cannot be found or is not supported." + #LF$ + #LF$ + VideoFile, #MR_ICONSTOP)
      EndIf
    Else
      nPosition = FindString(PageTitle, "x")

      If nPosition
        ExamineDesktops()
        DesktopWidth = DesktopWidth(0)
        DesktopHeight = DesktopHeight(0)
        VideoWidth = Val(Left(PageTitle, nPosition)) + 16
        VideoHeight = Val(Mid(PageTitle, nPosition + 1)) + 16
        ResizeWindow(0, DesktopWidth / 2 - VideoWidth / 2 - 4, DesktopHeight / 2 - VideoHeight / 2 - 16, VideoWidth, VideoHeight)
        ResizeGadget(0, 0, 0, VideoWidth, VideoHeight)
        HTMLCode.s = GetGadgetItemText(1, #PB_Web_HtmlCode)
        HTMLCode = ReplaceString(HTMLCode, "poster", "width='" + Str(VideoWidth - 16) + "' height='" + Str(VideoHeight - 16) + "' poster")
        SetGadgetItemText(0, #PB_Web_HtmlCode, HTMLCode)

        Repeat
          PageTitle = GetGadgetItemText(0, #PB_Web_PageTitle)

          If FindString(GetGadgetItemText(0, #PB_Web_HtmlCode), VideoFile) And PageTitle <> "" : Break : EndIf : WindowEvent() : Delay(1)

        ForEver
      EndIf
      StickyWindow(0, 1) : HideWindow(0, 0)
      Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
    EndIf
  EndIf
EndProcedure

VideoFile.s = "http://vjs.zencdn.net/v/oceans.mp4"
VideoFolder.s = GetCurrentDirectory()
BuildPlayer(VideoFile, VideoFolder, 1.5)
; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 5
; Folding = -
; UseIcon = Binaries/video.icns
; DisableDebugger
; EnableUnicode