﻿CompilerIf #PB_Compiler_Version < 550
  #MR_ICONSTOP = #Null
CompilerElse
  #MR_ICONSTOP = #PB_MessageRequester_Error
CompilerEndIf

Import "-stdlib=libc++ -mmacosx-version-min=10.7" : EndImport

Global VideoPlayer.s = #Null$

Procedure MaximizeRestoreWindowHandler()
  nWidth = WindowWidth(0) : nHeight = WindowHeight(0)
  ResizeGadget(0, 0, 0, nWidth, nHeight)
  PageTitle.s = GetGadgetItemText(0, #PB_Web_PageTitle)

  If Not FindString(PageTitle, "x")
    nPosition1 = FindString(VideoPlayer, "var current")

    If nPosition1
      nPosition2 = FindString(VideoPlayer, ";", nPosition1)
      VideoPlayer = ReplaceString(VideoPlayer, Mid(VideoPlayer, nPosition1, nPosition2 - nPosition1 + 1), "var current=" + PageTitle + ";")
    EndIf

    If ValD(PageTitle) > 0
      If FindString(VideoPlayer, "logo.png") : VideoPlayer = ReplaceString(VideoPlayer, "logo.png", "jhpjhp.png") : EndIf
    Else
      If FindString(VideoPlayer, "jhpjhp.png") : VideoPlayer = ReplaceString(VideoPlayer, "jhpjhp.png", "logo.png") : EndIf
    EndIf
  EndIf

  If FindString(VideoPlayer, "setWindowSize(0,0)")
    VideoPlayer = ReplaceString(VideoPlayer, "setWindowSize(0,0)", "setWindowSize(" + Str(nWidth - 16) + "," + Str(nHeight - 16) + ")")
  EndIf

  If FindString(VideoPlayer, "//videoPlayer.width=width;")
    VideoPlayer = ReplaceString(VideoPlayer, "//videoPlayer.width=width;", "videoPlayer.width=width;")
  Else
    VideoPlayer = ReplaceString(VideoPlayer, "videoPlayer.width=width;", "//videoPlayer.width=width;")
  EndIf

  If FindString(VideoPlayer, "//videoPlayer.height=height;")
    VideoPlayer = ReplaceString(VideoPlayer, "//videoPlayer.height=height;", "videoPlayer.height=height;")
  Else
    VideoPlayer = ReplaceString(VideoPlayer, "videoPlayer.height=height;", "//videoPlayer.height=height;")
  EndIf
  HideWindow(0, 1)
  SetGadgetItemText(0, #PB_Web_HtmlCode, VideoPlayer)
  Repeat : nWait + 1 : WindowEvent() : Delay(1) : Until nWait = 250
  HideWindow(0, 0)
EndProcedure

Procedure BuildPlayer(VideoFile.s, VideoFolder.s, VideoZoom.d = 1)
  If OpenWindow(0, 0, 0, 500, 500, "HTML5: Video Player", #PB_Window_SystemMenu | #PB_Window_MaximizeGadget | #PB_Window_ScreenCentered | #PB_Window_Invisible)
    WebGadget(0, 0, 0, 500, 500, #Null$)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setJavaScriptEnabled:", #YES)
    CocoaMessage(0, CocoaMessage(0, GadgetID(0), "preferences"), "setWebSecurityEnabled:", #NO)
    SetGadgetAttribute(0, #PB_Web_BlockPopupMenu, #True)
    SetGadgetAttribute(0, #PB_Web_BlockPopups, #True)
    IncludeFile "Includes/videoplayer.pbi"
    SetGadgetItemText(0, #PB_Web_HtmlCode, VideoPlayer)

    Repeat
      PageTitle.s = GetGadgetItemText(0, #PB_Web_PageTitle)

      If FindString(GetGadgetItemText(0, #PB_Web_HtmlCode), VideoFile) And PageTitle <> "" : Break : EndIf : WindowEvent() : Delay(1)

    ForEver

    If PageTitle = "error"
      If FileSize(VideoFolder + "TestFiles/moon.mp4") > 0
        BuildPlayer(VideoFolder + "TestFiles/moon.mp4", VideoFolder, 0.7)
      Else
        MessageRequester("HTML5 Video Player with jQuery", "It seems that this video file cannot be found or is not supported." + #LF$ + #LF$ + VideoFile, #MR_ICONSTOP)
      EndIf
    Else
      nPosition = FindString(PageTitle, "x")

      If nPosition
        ExamineDesktops()
        DesktopWidth = DesktopWidth(0)
        DesktopHeight = DesktopHeight(0)
        VideoWidth = Val(Left(PageTitle, nPosition)) + 16
        VideoHeight = Val(Mid(PageTitle, nPosition + 1)) + 16
        ResizeWindow(0, DesktopWidth / 2 - VideoWidth / 2 - 4, DesktopHeight / 2 - VideoHeight / 2 - 16, VideoWidth, VideoHeight)
        ResizeGadget(0, 0, 0, VideoWidth, VideoHeight)
      EndIf
      BindEvent(#PB_Event_MaximizeWindow, @MaximizeRestoreWindowHandler())
      BindEvent(#PB_Event_RestoreWindow, @MaximizeRestoreWindowHandler())
      StickyWindow(0, 1) : HideWindow(0, 0)
      Repeat : Until WaitWindowEvent() = #PB_Event_CloseWindow
    EndIf
  EndIf
EndProcedure

VideoFile.s = "http://vjs.zencdn.net/v/oceans.mp4"
VideoFolder.s = GetCurrentDirectory()
BuildPlayer(VideoFile, VideoFolder, 1.5)
; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 5
; Folding = -
; UseIcon = Binaries/video.icns
; DisableDebugger
; EnableUnicode